@use '../../../global/styles/styles-variables' as *;
@use 'styles/navigation-sidebar.variables' as *;

:host {
	@include digi-navigation-sidebar--variables;

	position: relative;
	display: block;

	.digi-navigation-sidebar {
		height: 100%;
	}

	.digi-navigation-sidebar__wrapper {
		$base: '.digi-navigation-sidebar__wrapper';
		$isStatic: false;

		top: 0;
		bottom: 0;
		z-index: var(--digi--navigation-sidebar--wrapper--z-index);
		visibility: hidden;
		opacity: 0;
		height: 100%;
		background-color: var(--digi--navigation-sidebar--wrapper--background-color);
		padding: var(--digi--navigation-sidebar--wrapper--padding);
		box-sizing: border-box;
		width: var(--digi--navigation-sidebar--wrapper--width);
		margin: var(--digi--navigation-sidebar--wrapper--margin);

		@media (prefers-reduced-motion) {
			--digi--navigation-sidebar--wrapper--transition: $animation__duration--reduced;
		}

		// MOBILE
		@media screen and (max-width: $digi--breakpoint--medium-below) {
			transition: var(--digi--navigation-sidebar--wrapper--transition);

			&#{$base}--mobile--default {
				--digi--navigation-sidebar--wrapper--width: var(--digi--navigation-sidebar--wrapper--width--small);
			}
			&#{$base}--mobile--fullwidth {
				--digi--navigation-sidebar--wrapper--width: var(--digi--navigation-sidebar--wrapper--width--small--fullwidth);
			}
		}

		&--active {
			opacity: 1;
			visibility: initial;
		}

		&--static {
			$isStatic: true;

			@media screen and (max-width: $digi--breakpoint--medium-below) {
				position: var(--digi--navigation-sidebar--wrapper--position);
			}

			@media screen and (min-width: $digi--breakpoint--medium) {
				--digi--navigation-sidebar--wrapper--width: 100%;
			}
		}

		&--over {
			@media screen and (min-width: $digi--breakpoint--medium) {
				box-shadow: var(--digi--navigation-sidebar--wrapper--box-shadow);
			}
		}

		&--over,
		&--push {
			transition: var(--digi--navigation-sidebar--wrapper--transition);
			position: var(--digi--navigation-sidebar--wrapper--position);
		}

		&--push {
			&#{$base}--start {
				@media screen and (min-width: $digi--breakpoint--medium) {
					border-right: var(--digi--navigation-sidebar--wrapper--border);
				}
			}
			&#{$base}--end {
				@media screen and (min-width: $digi--breakpoint--medium) {
					border-left: var(--digi--navigation-sidebar--wrapper--border);
				}
			}
		}

		&--backdrop {
			&#{$base}--push,
			&#{$base}--over {
				@media screen and (min-width: $digi--breakpoint--medium) {
					--digi--navigation-sidebar--wrapper--box-shadow: var(--digi--navigation-sidebar--wrapper--box-shadow--backdrop);
					box-shadow: var(--digi--navigation-sidebar--wrapper--box-shadow);
				}
			}
		}

		&--start {
			@media screen and (min-width: $digi--breakpoint--medium) {
				left: 0;

				&#{$base}--active {
					--digi--navigation-sidebar--wrapper--margin: 0;
				}
			}
		}

		&--end {
			@media screen and (min-width: $digi--breakpoint--medium) {
				right: 0;
				--digi--navigation-sidebar--wrapper--margin: 0 -21.875rem 0 0;

				&#{$base}--active {
					--digi--navigation-sidebar--wrapper--margin: 0;
				}
			}
		}

		&--mobile--start {
			@media screen and (max-width: $digi--breakpoint--medium-below) {
				left: 0;

				&#{$base}--active {
					--digi--navigation-sidebar--wrapper--margin: 0;
				}
			}
		}

		&--mobile--end {
			@media screen and (max-width: $digi--breakpoint--medium-below) {
				right: 0;
				--digi--navigation-sidebar--wrapper--margin: 0 -21.875rem 0 0;

				&#{$base}--active {
					--digi--navigation-sidebar--wrapper--margin: 0;
				}
			}
		}

		&--sticky-header {
			.digi-navigation-sidebar__inner {
				display: flex;
				flex-direction: column;
				max-height: 100vh;
			}

			.digi-navigation-sidebar__header {
				border-bottom: var(--digi--navigation-sidebar--header--border);
			}

			.digi-navigation-sidebar__content {
				overflow-y: auto;
				overflow-x: hidden;
				max-height: 100vh;
			}

			// --------------- OVERRIDES for Static
			&#{$base}--static {
				.digi-navigation-sidebar__inner {
					@media screen and (min-width: $digi--breakpoint--medium) {
						max-height: unset;
					}
				}
				.digi-navigation-sidebar__content {
					@media screen and (min-width: $digi--breakpoint--medium) {
						overflow-y: unset;
						overflow-x: unset;
						max-height: unset;
					}
				}
			}
		}

		// Scroll content without sticky header
		&:not(#{$base}--sticky-header) {
			.digi-navigation-sidebar__inner {
				overflow-y: auto;
				overflow-x: hidden;
				max-height: 100vh;
			}

			// --------------- OVERRIDES for Static
			&#{$base}--static {
				.digi-navigation-sidebar__inner {
					@media screen and (min-width: $digi--breakpoint--medium) {
						overflow-y: unset;
						overflow-x: unset;
						max-height: unset;
					}
				}
			}
		}
	}

	.digi-navigation-sidebar__header {
		display: flex;
		flex-wrap: wrap;
		align-items: center;
		padding: var(--digi--navigation-sidebar--header--padding);

		&--close-button--end {
			justify-content: flex-end;
		}

		// &--reversed {
		//   flex-direction: column-reverse;
		// }
	}

	.digi-navigation-sidebar__heading {
		font-family: var(--digi--navigation-sidebar--heading--font-family);
		font-size: var(--digi--navigation-sidebar--heading--font-size);
		font-weight: var(--digi--navigation-sidebar--heading--font-weight);
		color: var(--digi--navigation-sidebar--heading--color);
		margin: 0 auto 0 0;

		&:focus {
			outline: none;
		}

		@media (min-width: $digi--breakpoint--medium) {
			font-size: var(--digi--navigation-sidebar--heading--font-size--desktop);
		}
	}

	.digi-navigation-sidebar__close-button {
		--digi--button--padding--medium: var(--digi--navigation-sidebar--close-button--padding);
		--digi--button--outline--focus: solid 2px var(--digi--color--border--secondary);
	}

	.digi-navigation-sidebar__backdrop {
		visibility: hidden;
		opacity: 0;
		transition: var(--digi--navigation-sidebar--backdrop--transition);
		position: relative;
		z-index: var(--digi--navigation-sidebar--backdrop--z-index);

		@media (prefers-reduced-motion) {
			--digi--navigation-sidebar--backdrop--transition: $animation__duration--reduced;
		}

		&--active,
		&--active--mobile {
			background: var(--digi--navigation-sidebar--backdrop--background);
			width: 100%;
			height: 100%;
			position: fixed;
			top: 0;
			left: 0;
			visibility: visible;
			opacity: 1;
		}

		@media screen and (min-width: $digi--breakpoint--medium) {
			display: none;

			&--active {
				display: block;
			}
		}

		@media screen and (max-width: $digi--breakpoint--medium-below) {
			display: none;

			&--active--mobile {
				display: block;
			}
		}

		&--hidden {
			display: none;

			&--active--mobile {
				display: block;
			}
		}

		&--hidden {
			display: none;
		}
	}
}
